/* probes.c ********************\
*                               *
*   Reynolds/Favre averaging    *
*  of computed DNS or LES data  *
*      for round jet flow       *
*                               *
*     v. 0.5, 19 Mar 2001       *
*                               *
\*******************************/


#include <stdio.h>
#include <stdlib.h>


float *ArrayAllocMem(unsigned size)
{
float *x;

    if ((x = (float *)malloc(sizeof(float)*size)) == NULL) {
	fprintf(stderr, "can't allocate memory.\n");
	exit(-1);
    }
    return x;

} /* end ArrayAllocMem() */


main()
{
unsigned
    HIG, step, stepStart, stepEnd, i, j;
    
float 
    *probeR, *probeRU, *R1, *RU1;
    
FILE 
    *pFprobes, *pFprofile;
    

    /*--- get some parameters ---*/
    printf("stepStart = "); scanf("%d", &stepStart);
    printf("stepEnd = ");   scanf("%d", &stepEnd);
    printf("HIG = ");       scanf("%d", &HIG);

    /*--- allocate memory ---*/
    probeR  = ArrayAllocMem(HIG);
    probeRU = ArrayAllocMem(HIG);
    R1 = ArrayAllocMem(HIG);
    RU1 = ArrayAllocMem(HIG);
    
    /*---*/
    for (i = 0; i < HIG; i++) {
	R1 [i] = 0.;
	RU1[i] = 0.;
    }

    /*--- opens probes file ---*/
    if((pFprobes = fopen("probes.dat", "rb")) == NULL) {
	fprintf(stderr, "can't open file \"probes.dat\".\n");
	exit( -1 );
    }

    /*--- read ... ---*/
    for( i = 0;; i++ ) {
   
	/* read step */
        fread(&step, sizeof(step), 1, pFprobes);

	if (step > stepEnd)
	    break;

	if (step < stepStart) { /* simple read, not add */
	    /* idle */
	    fread(probeR,  sizeof(float)*HIG, 1, pFprobes);
	    fread(probeRU, sizeof(float)*HIG, 1, pFprobes);
	} /* end if() */
	else{
	    /* print it out */
	    printf("step = %d\n", step);
	    /* */
	    fread(probeR,  sizeof(float)*HIG, 1, pFprobes);
	    fread(probeRU, sizeof(float)*HIG, 1, pFprobes);
	    /**/
	    for (j = 0; j < HIG; j++) {
		R1[j] += probeR[j];
		RU1[j] += probeRU[j];
	    }
	}
    }

    /*--- close file of probes ---*/
    fclose(pFprobes);
    
    /*--- determine Favre averaged (here RU means F.av. U) ---*/
    for (j = 0; j < HIG; j++) 
       RU1[j] /= R1[j];
       
    /*--- write profiles ---*/
    if ((pFprofile = fopen("probe.dat", "w")) == NULL) {
	fprintf(stderr, "can't open file.\n");
	exit(-1);
    }
    fprintf(pFprofile, "%d\n1\n", HIG+2);
    fprintf(pFprofile, "%f %3.2f \n", -0.00001, 0.);
    
    /*---*/
    for (j = 0; j < HIG; j++)
	fprintf(pFprofile, "%d %3.2f \n", j, RU1[j]);
    
    /*---*/
    fprintf(pFprofile, "%f %3.2f \n", HIG-1+0.00001, 210.);
    fclose(pFprofile);
    
    /*---*/
    return 0;
    
} /* end main() */

/*--- end probes.c ---*/